plugins {
    java
    application
    kotlin("jvm") version "1.3.70"
}

group = "nl.voidcorp"
version = "1.0-SNAPSHOT"

repositories {
    jcenter()
}

fun DependencyHandlerScope.exposed(part: String) = implementation("org.jetbrains.exposed", part, "0.22.1")

dependencies {
    implementation(kotlin("stdlib-jdk8"))
    implementation("net.dv8tion:JDA:4.1.1_108") {
        exclude(module = "opus-java")
    }
    testImplementation("junit", "junit", "4.12")
    implementation("ch.qos.logback:logback-classic:1.2.3")
    exposed("exposed-core")
    exposed("exposed-dao")
    exposed("exposed-jdbc")
    implementation("org.xerial:sqlite-jdbc:3.30.1")
    implementation("com.impossibl.pgjdbc-ng:pgjdbc-ng:0.8.3")

}

configure<JavaPluginConvention> {
    sourceCompatibility = JavaVersion.VERSION_1_8
}
tasks {
    compileKotlin {
        kotlinOptions.jvmTarget = "1.8"
    }
    compileTestKotlin {
        kotlinOptions.jvmTarget = "1.8"
    }

    distTar {
        archiveName = "watchtower.tar"
    }
}

application {
    applicationName = "watchtower"
    mainClassName = "nl.voidcorp.watchtower.MainKt"
}

